---
permalink: /docs/adapters/index.html
layout: docs
---

Adapters are the interface to the service you want your hubot to run on.

## Official Adapters

Hubot includes two official adapters:

* [Shell](/docs/adapters/shell.md), i.e. for use with development
* [Campfire](/docs/adapters/campfire.md)

## Third-party Adapters

Third-party adapters are available as `npm` packages. Here is a list of known
adapters, but please [submit an issue](https://github.com/github/hubot/issues)
to have yours added to the list:


* [AIM](https://github.com/shaundubuque/hubot-aim)
* [ChatWork](https://github.com/akiomik/hubot-chatwork)
* [Dasher](https://github.com/nebulist/hubot-dasher)
* [Fleep](https://github.com/anroots/hubot-fleep)
* [Flowdock](https://github.com/flowdock/hubot-flowdock)
* [Gitter](https://github.com/huafu/hubot-gitter2)
* [Gtalk](https://github.com/atmos/hubot-gtalk)
* [Hall](https://github.com/Hall/hubot-hall)
* [HipChat](https://github.com/hipchat/hubot-hipchat)
* [iMessage](https://github.com/lazerwalker/hubot-imessage)
* [IRC](https://github.com/nandub/hubot-irc)
* [Jabbr](https://github.com/smoak/hubot-jabbr)
* [Let's Chat](https://github.com/sdelements/hubot-lets-chat)
* [Lingr](https://github.com/miyagawa/hubot-lingr)
* [Mattermost](https://github.com/renanvicente/hubot-mattermost)
* [QQ](https://github.com/xhan/qqbot)
* [Partychat](https://github.com/iangreenleaf/hubot-partychat-hooks)
* [Proxy](https://github.com/Hammertime38/hubot-proxy) - This adapter allows the base application to observe, handle, and control events sent to the proxied adapter, all defined in a config object at the root of the module.
* [Rocket.Chat](https://github.com/RocketChat/hubot-rocketchat)
* [Slack](https://github.com/slackhq/hubot-slack)
* [Skype](https://github.com/netpro2k/hubot-skype)
* [SkypeWeb](https://github.com/sdimkov/hubot-skype-web)
* [Skyweb](https://github.com/EllisV/hubot-skyweb)
* [Talker](https://github.com/unixcharles/hubot-talker)
* [Telegram](https://github.com/lukefx/hubot-telegram)
* [Twilio IP Messaging](https://github.com/philnash/hubot-twilio-ip-messaging)
* [Twilio SMS](https://github.com/jkarmel/hubot-twilio)
* [Twitter](https://github.com/MathildeLemee/hubot-twitter)
* [Typetalk](https://github.com/nulab/hubot-typetalk)
* [VictorOps](https://github.com/victorops/hubot-victorops)
* [Visual Studio Online](https://github.com/scrumdod/hubot-VSOnline)
* [XMPP](https://github.com/markstory/hubot-xmpp)
* [Yammer](https://github.com/athieriot/hubot-yammer)

## Writing Your Own Adapter

Interested in adding your own adapter? Check out our documentation for [developing adapters](/docs/adapters/development.md)
